import unittest
from other.student4.Calculator import StringCalculator  # Marvin

class TestMyCasesOnStudent4(unittest.TestCase):
    def setUp(self):
        self.calc = StringCalculator()

    def test_empty_string(self):
        self.assertEqual(self.calc.add(""), 0)

    def test_single_number(self):
        self.assertEqual(self.calc.add("1"), 1)

    def test_two_numbers(self):
        self.assertEqual(self.calc.add("1,2"), 3)

    def test_multiple_numbers(self):
        self.assertEqual(self.calc.add("1,2,3,4,5"), 15)

    def test_numbers_with_newline(self):
        self.assertEqual(self.calc.add("1\n2,3"), 6)

    def test_multiple_newlines(self):
        self.assertEqual(self.calc.add("1\n2\n3\n4\n5"), 15)

    def test_negative_number(self):
        with self.assertRaises(ValueError) as e:
            self.calc.add("1,-2,3")
        self.assertEqual(str(e.exception), "Negative numbers are not allowed: -2")

    def test_multiple_negative_numbers(self):
        with self.assertRaises(ValueError) as e:
            self.calc.add("1,-2,-3,4")
        self.assertEqual(str(e.exception), "Negative numbers are not allowed: -2, -3")

    def test_custom_delimiter(self):
        self.assertEqual(self.calc.add("//;\n1;2"), 3)

    def test_custom_delimiter_with_newline(self):
        self.assertEqual(self.calc.add("//;\n1;2\n3"), 6)

    def test_ignore_numbers_over_1000(self):
        self.assertEqual(self.calc.add("2,1001"), 2)

    def test_custom_delimiter_any_length(self):
        self.assertEqual(self.calc.add("//[***]\n1***2***3"), 6)

if __name__ == "__main__":
    unittest.main()
