import unittest
from my_string_calculator import StringCalculator 

class TestStudent1OnMyCalc(unittest.TestCase):
    def setUp(self):
        self.c = StringCalculator()

    def test_empty(self):
        self.assertEqual(self.c.add(""), 0)

    def test_oneNumber(self):
        self.assertEqual(self.c.add("1"), 1)
    
    def test_addingTwoNumbers(self):
        self.assertEqual(self.c.add("1,2"), 3)

    def test_addingTwoNumbersWithZero(self):
        self.assertEqual(self.c.add("0,5"), 5)

    def test_handleFloat(self):
        with self.assertRaises(Exception):
            self.c.add("3.5")

    def test_handleLetter(self):
        with self.assertRaises(Exception):
            self.c.add("1, z")

    def test_addWithBackslashN(self):
        self.assertEqual(self.c.add("1\n2,3"), 6)

    def test_negativeValues(self):
        with self.assertRaises(ValueError):
            self.c.add("-3")

    def test_delimiter(self):
        self.assertEqual(self.c.add("//;\n1;2"), 3)

    def test_thousandone(self):
        self.assertEqual(self.c.add("2, 1001"), 2)

    def test_multidelimiter(self):
        self.assertEqual(self.c.add("//[***]\n1***2***3"), 6)

    def test_multi_negative(self):
        with self.assertRaises(ValueError):
            self.c.add("-3, -4")

    def test_space_between_numbers(self):
        self.assertEqual(self.c.add(" 4  , 5"), 9)

    def test_multiple_num_with_thousandone(self):
        self.assertEqual(self.c.add(" 2, 1001, 5"), 7)

    def test_empty_text(self):
        self.assertEqual(self.c.add("//;\n"), 0)

    def test_one_number_with_empty_string(self):
        self.assertEqual(self.c.add("1,"), 1)

    def test_negative_with_positive(self):
        with self.assertRaises(ValueError):
            self.c.add("-2, 5")

    def test_mixture(self):
        with self.assertRaises(ValueError):
            self.c.add("//;\n-1;2;1001;-3")

if __name__ == "__main__":
    unittest.main()
